# -*- coding: utf-8 -*-
assert '…' == '\xe2\x80\xa6', "file encoding error"

# Copyright 2013 Axel Walthelm
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

import bisect

# Find the smallest index i with sortedList[i] == value
def index(sortedList, value):
    i = bisect.bisect_left(sortedList, value)
    if i != len(sortedList) and sortedList[i] == value:
        return i
    raise ValueError

# Find the largest index i with sortedList[value] < value
def largestIndexLess(sortedList, value):
    i = bisect.bisect_left(sortedList, value)
    if i:
        return i-1
    raise ValueError

# Find the largest index i with sortedList[value] <= value
def largestIndexLessOrEqual(sortedList, value):
    i = bisect.bisect_right(sortedList, value)
    if i:
        return i-1
    raise ValueError

# Find the smallest index i with sortedList[value] > value
def smallestIndexGreater(sortedList, value):
    i = bisect.bisect_right(sortedList, value)
    if i != len(sortedList):
        return i
    raise ValueError

# Find the smallest index i with sortedList[value] >= value
def smallestIndexGreaterOrEqual(sortedList, value):
    i = bisect.bisect_left(sortedList, value)
    if i != len(sortedList):
        return i
    raise ValueError
